IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKToken1')
    ALTER TABLE Token DROP CONSTRAINT FKToken1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKParam1')
    ALTER TABLE Param DROP CONSTRAINT FKParam1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKFeature1')
    ALTER TABLE Feature DROP CONSTRAINT FKFeature1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKWidgetType1')
    ALTER TABLE WidgetType DROP CONSTRAINT FKWidgetType1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKWidgetDefault1')
    ALTER TABLE WidgetDefault DROP CONSTRAINT FKWidgetDefault1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKSharedData1')
    ALTER TABLE SharedData DROP CONSTRAINT FKSharedData1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKPreference1')
    ALTER TABLE Preference DROP CONSTRAINT FKPreference1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKParticipant1')
    ALTER TABLE Participant DROP CONSTRAINT FKParticipant1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKPreferenceDefault1')
    ALTER TABLE PreferenceDefault DROP CONSTRAINT FKPreferenceDefault1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKWidgetInstance1')
    ALTER TABLE WidgetInstance DROP CONSTRAINT FKWidgetInstance1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKStartFile1')
    ALTER TABLE StartFile DROP CONSTRAINT FKStartFile1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKDescription1')
    ALTER TABLE Description DROP CONSTRAINT FKDescription1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKAccessRequest1')
    ALTER TABLE AccessRequest DROP CONSTRAINT FKAccessRequest1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKName1')
    ALTER TABLE Name DROP CONSTRAINT FKName1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKLicense1')
    ALTER TABLE License DROP CONSTRAINT FKLicense1;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'F' AND name = 'FKWidgetIcon1')
    ALTER TABLE WidgetIcon DROP CONSTRAINT FKWidgetIcon1;

-- ----------------------------------------------------------------------- 
-- Token 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Token')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__8000 nvarchar(256), @cn3511604_130f4bc0ee4__7fff nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Token'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__8000, @cn3511604_130f4bc0ee4__7fff
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__8000+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fff)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__8000, @cn3511604_130f4bc0ee4__7fff
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Token
END;

-- ----------------------------------------------------------------------- 
-- ServerFeature 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'ServerFeature')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ffe nvarchar(256), @cn3511604_130f4bc0ee4__7ffd nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'ServerFeature'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffe, @cn3511604_130f4bc0ee4__7ffd
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ffe+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ffd)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffe, @cn3511604_130f4bc0ee4__7ffd
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE ServerFeature
END;

-- ----------------------------------------------------------------------- 
-- Param 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Param')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ffc nvarchar(256), @cn3511604_130f4bc0ee4__7ffb nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Param'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffc, @cn3511604_130f4bc0ee4__7ffb
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ffc+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ffb)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffc, @cn3511604_130f4bc0ee4__7ffb
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Param
END;

-- ----------------------------------------------------------------------- 
-- Feature 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Feature')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ffa nvarchar(256), @cn3511604_130f4bc0ee4__7ff9 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Feature'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffa, @cn3511604_130f4bc0ee4__7ff9
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ffa+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ff9)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ffa, @cn3511604_130f4bc0ee4__7ff9
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Feature
END;

-- ----------------------------------------------------------------------- 
-- ApiKey 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'ApiKey')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ff8 nvarchar(256), @cn3511604_130f4bc0ee4__7ff7 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'ApiKey'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff8, @cn3511604_130f4bc0ee4__7ff7
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ff8+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ff7)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff8, @cn3511604_130f4bc0ee4__7ff7
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE ApiKey
END;

-- ----------------------------------------------------------------------- 
-- Whitelist 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Whitelist')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ff6 nvarchar(256), @cn3511604_130f4bc0ee4__7ff5 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Whitelist'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff6, @cn3511604_130f4bc0ee4__7ff5
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ff6+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ff5)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff6, @cn3511604_130f4bc0ee4__7ff5
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Whitelist
END;

-- ----------------------------------------------------------------------- 
-- WidgetType 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetType')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ff4 nvarchar(256), @cn3511604_130f4bc0ee4__7ff3 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'WidgetType'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff4, @cn3511604_130f4bc0ee4__7ff3
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ff4+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ff3)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff4, @cn3511604_130f4bc0ee4__7ff3
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE WidgetType
END;

-- ----------------------------------------------------------------------- 
-- WidgetService 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetService')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ff2 nvarchar(256), @cn3511604_130f4bc0ee4__7ff1 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'WidgetService'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff2, @cn3511604_130f4bc0ee4__7ff1
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ff2+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7ff1)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff2, @cn3511604_130f4bc0ee4__7ff1
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE WidgetService
END;

-- ----------------------------------------------------------------------- 
-- WidgetDefault 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetDefault')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7ff0 nvarchar(256), @cn3511604_130f4bc0ee4__7fef nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'WidgetDefault'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff0, @cn3511604_130f4bc0ee4__7fef
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7ff0+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fef)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7ff0, @cn3511604_130f4bc0ee4__7fef
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE WidgetDefault
END;

-- ----------------------------------------------------------------------- 
-- SharedData 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'SharedData')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fee nvarchar(256), @cn3511604_130f4bc0ee4__7fed nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'SharedData'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fee, @cn3511604_130f4bc0ee4__7fed
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fee+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fed)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fee, @cn3511604_130f4bc0ee4__7fed
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE SharedData
END;

-- ----------------------------------------------------------------------- 
-- Preference 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Preference')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fec nvarchar(256), @cn3511604_130f4bc0ee4__7feb nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Preference'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fec, @cn3511604_130f4bc0ee4__7feb
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fec+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7feb)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fec, @cn3511604_130f4bc0ee4__7feb
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Preference
END;

-- ----------------------------------------------------------------------- 
-- Participant 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Participant')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fea nvarchar(256), @cn3511604_130f4bc0ee4__7fe9 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Participant'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fea, @cn3511604_130f4bc0ee4__7fe9
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fea+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fe9)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fea, @cn3511604_130f4bc0ee4__7fe9
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Participant
END;

-- ----------------------------------------------------------------------- 
-- PreferenceDefault 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'PreferenceDefault')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fe8 nvarchar(256), @cn3511604_130f4bc0ee4__7fe7 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'PreferenceDefault'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe8, @cn3511604_130f4bc0ee4__7fe7
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fe8+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fe7)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe8, @cn3511604_130f4bc0ee4__7fe7
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE PreferenceDefault
END;

-- ----------------------------------------------------------------------- 
-- WidgetInstance 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetInstance')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fe6 nvarchar(256), @cn3511604_130f4bc0ee4__7fe5 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'WidgetInstance'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe6, @cn3511604_130f4bc0ee4__7fe5
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fe6+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fe5)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe6, @cn3511604_130f4bc0ee4__7fe5
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE WidgetInstance
END;

-- ----------------------------------------------------------------------- 
-- StartFile 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'StartFile')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fe4 nvarchar(256), @cn3511604_130f4bc0ee4__7fe3 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'StartFile'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe4, @cn3511604_130f4bc0ee4__7fe3
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fe4+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fe3)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe4, @cn3511604_130f4bc0ee4__7fe3
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE StartFile
END;

-- ----------------------------------------------------------------------- 
-- Description 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Description')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fe2 nvarchar(256), @cn3511604_130f4bc0ee4__7fe1 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Description'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe2, @cn3511604_130f4bc0ee4__7fe1
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fe2+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fe1)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe2, @cn3511604_130f4bc0ee4__7fe1
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Description
END;

-- ----------------------------------------------------------------------- 
-- AccessRequest 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'AccessRequest')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fe0 nvarchar(256), @cn3511604_130f4bc0ee4__7fdf nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'AccessRequest'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe0, @cn3511604_130f4bc0ee4__7fdf
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fe0+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fdf)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fe0, @cn3511604_130f4bc0ee4__7fdf
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE AccessRequest
END;

-- ----------------------------------------------------------------------- 
-- Name 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Name')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fde nvarchar(256), @cn3511604_130f4bc0ee4__7fdd nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Name'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fde, @cn3511604_130f4bc0ee4__7fdd
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fde+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fdd)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fde, @cn3511604_130f4bc0ee4__7fdd
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Name
END;

-- ----------------------------------------------------------------------- 
-- License 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'License')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fdc nvarchar(256), @cn3511604_130f4bc0ee4__7fdb nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'License'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fdc, @cn3511604_130f4bc0ee4__7fdb
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fdc+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fdb)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fdc, @cn3511604_130f4bc0ee4__7fdb
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE License
END;

-- ----------------------------------------------------------------------- 
-- WidgetIcon 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetIcon')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fda nvarchar(256), @cn3511604_130f4bc0ee4__7fd9 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'WidgetIcon'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fda, @cn3511604_130f4bc0ee4__7fd9
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fda+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fd9)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fda, @cn3511604_130f4bc0ee4__7fd9
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE WidgetIcon
END;

-- ----------------------------------------------------------------------- 
-- Widget 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Widget')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fd8 nvarchar(256), @cn3511604_130f4bc0ee4__7fd7 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'Widget'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fd8, @cn3511604_130f4bc0ee4__7fd7
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fd8+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fd7)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fd8, @cn3511604_130f4bc0ee4__7fd7
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE Widget
END;

-- ----------------------------------------------------------------------- 
-- OPENJPA_SEQUENCE_TABLE 
-- ----------------------------------------------------------------------- 

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'OPENJPA_SEQUENCE_TABLE')
BEGIN
  DECLARE @tn3511604_130f4bc0ee4__7fd6 nvarchar(256), @cn3511604_130f4bc0ee4__7fd5 nvarchar(256)
  DECLARE refcursor CURSOR FOR
  SELECT object_name(objs.parent_obj) tablename, objs.name constraintname
    FROM sysobjects objs JOIN sysconstraints cons ON objs.id = cons.constid
    WHERE objs.xtype != 'PK' AND object_name(objs.parent_obj) = 'OPENJPA_SEQUENCE_TABLE'  OPEN refcursor
  FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fd6, @cn3511604_130f4bc0ee4__7fd5
  WHILE @@FETCH_STATUS = 0
    BEGIN
      EXEC ('ALTER TABLE '+@tn3511604_130f4bc0ee4__7fd6+' DROP CONSTRAINT '+@cn3511604_130f4bc0ee4__7fd5)
      FETCH NEXT FROM refcursor INTO @tn3511604_130f4bc0ee4__7fd6, @cn3511604_130f4bc0ee4__7fd5
    END
  CLOSE refcursor
  DEALLOCATE refcursor
  DROP TABLE OPENJPA_SEQUENCE_TABLE
END;

-- ----------------------------------------------------------------------- 
-- OPENJPA_SEQUENCE_TABLE 
-- ----------------------------------------------------------------------- 

CREATE TABLE OPENJPA_SEQUENCE_TABLE
(
    ID SMALLINT NOT NULL,
    SEQUENCE_VALUE DECIMAL(19,0),
    PRIMARY KEY (ID)
);

-- ----------------------------------------------------------------------- 
-- Widget 
-- ----------------------------------------------------------------------- 

CREATE TABLE Widget
(
    id INT NOT NULL,
    jpa_version INT,
    height INT,
    width INT,
    guid VARCHAR(255) NOT NULL,
    widget_author VARCHAR(255),
    widget_author_email VARCHAR(320),
    widget_author_href TEXT,
    widget_version VARCHAR(255),
    PRIMARY KEY (id)
);

CREATE UNIQUE INDEX UNWidget1 ON Widget (guid);

-- ----------------------------------------------------------------------- 
-- WidgetIcon 
-- ----------------------------------------------------------------------- 

CREATE TABLE WidgetIcon
(
    id INT NOT NULL,
    jpa_version INT,
    src TEXT,
    height INT,
    width INT,
    lang VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetIcon1 ON WidgetIcon (widget_id);

-- ----------------------------------------------------------------------- 
-- License 
-- ----------------------------------------------------------------------- 

CREATE TABLE License
(
    id INT NOT NULL,
    jpa_version INT,
    href TEXT,
    text TEXT,
    dir VARCHAR(255),
    lang VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXLicense1 ON License (widget_id);

-- ----------------------------------------------------------------------- 
-- Name 
-- ----------------------------------------------------------------------- 

CREATE TABLE Name
(
    id INT NOT NULL,
    jpa_version INT,
    name TEXT,
    shortName VARCHAR(255),
    dir VARCHAR(255),
    lang VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXName1 ON Name (widget_id);

-- ----------------------------------------------------------------------- 
-- AccessRequest 
-- ----------------------------------------------------------------------- 

CREATE TABLE AccessRequest
(
    id INT NOT NULL,
    jpa_version INT,
    origin VARCHAR(2048),
    subdomains CHAR(1),
    granted CHAR(1),
    widget_id INT NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXAccessRequest1 ON AccessRequest (widget_id);

-- ----------------------------------------------------------------------- 
-- Description 
-- ----------------------------------------------------------------------- 

CREATE TABLE Description
(
    id INT NOT NULL,
    jpa_version INT,
    content TEXT,
    dir VARCHAR(255),
    lang VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXDescription1 ON Description (widget_id);

-- ----------------------------------------------------------------------- 
-- StartFile 
-- ----------------------------------------------------------------------- 

CREATE TABLE StartFile
(
    id INT NOT NULL,
    jpa_version INT,
    url TEXT,
    charset VARCHAR(255),
    lang VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXStartFile1 ON StartFile (widget_id);

-- ----------------------------------------------------------------------- 
-- WidgetInstance 
-- ----------------------------------------------------------------------- 

CREATE TABLE WidgetInstance
(
    id INT NOT NULL,
    jpa_version INT,
    apikey VARCHAR(255) NOT NULL,
    userId VARCHAR(255) NOT NULL,
    sharedDataKey VARCHAR(255),
    nonce VARCHAR(255),
    idKey VARCHAR(255) NOT NULL,
    opensocialToken TEXT NOT NULL,
    widget_id INT NOT NULL,
    updated CHAR(1),
    shown CHAR(1),
    hidden CHAR(1),
    locked CHAR(1),
    lang VARCHAR(255),
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetInstance1 ON WidgetInstance (widget_id);

CREATE UNIQUE INDEX UNWidgetInstance1 ON WidgetInstance (idKey);

-- ----------------------------------------------------------------------- 
-- PreferenceDefault 
-- ----------------------------------------------------------------------- 

CREATE TABLE PreferenceDefault
(
    id INT NOT NULL,
    jpa_version INT,
    widget_id INT,
    preference VARCHAR(255) NOT NULL,
    value VARCHAR(1024) NOT NULL,
    readOnly CHAR(1),
    PRIMARY KEY (id)
);

CREATE INDEX IXPreferenceDefault1 ON PreferenceDefault (widget_id);

-- ----------------------------------------------------------------------- 
-- Participant 
-- ----------------------------------------------------------------------- 

CREATE TABLE Participant
(
    id INT NOT NULL,
    jpa_version INT,
    participant_id VARCHAR(255) NOT NULL,
    participant_display_name VARCHAR(255) NOT NULL,
    participant_thumbnail_url VARCHAR(1024),
    sharedDataKey VARCHAR(255) NOT NULL,
    widget_id INT NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXParticipant1 ON Participant (widget_id);

-- ----------------------------------------------------------------------- 
-- Preference 
-- ----------------------------------------------------------------------- 

CREATE TABLE Preference
(
    id INT NOT NULL,
    jpa_version INT,
    widget_instance_id INT,
    dkey VARCHAR(255),
    dvalue TEXT,
    readOnly CHAR(1),
    PRIMARY KEY (id)
);

CREATE INDEX IXPreference1 ON Preference (widget_instance_id);

CREATE UNIQUE INDEX UNPreference1 ON Preference (widget_instance_id, dkey);

-- ----------------------------------------------------------------------- 
-- SharedData 
-- ----------------------------------------------------------------------- 

CREATE TABLE SharedData
(
    id INT NOT NULL,
    jpa_version INT,
    sharedDataKey VARCHAR(255),
    dkey VARCHAR(255),
    dvalue TEXT,
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXSharedData1 ON SharedData (widget_id);

-- ----------------------------------------------------------------------- 
-- WidgetDefault 
-- ----------------------------------------------------------------------- 

CREATE TABLE WidgetDefault
(
    widgetContext VARCHAR(255) NOT NULL,
    jpa_version INT,
    widgetId INT NOT NULL,
    PRIMARY KEY (widgetContext)
);

CREATE INDEX IXWidgetDefault1 ON WidgetDefault (widgetId);

-- ----------------------------------------------------------------------- 
-- WidgetService 
-- ----------------------------------------------------------------------- 

CREATE TABLE WidgetService
(
    id INT NOT NULL,
    jpa_version INT,
    service_name VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetService1 ON WidgetService (service_name);

-- ----------------------------------------------------------------------- 
-- WidgetType 
-- ----------------------------------------------------------------------- 

CREATE TABLE WidgetType
(
    id INT NOT NULL,
    jpa_version INT,
    widget_context VARCHAR(255),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetType1 ON WidgetType (widget_id);

-- ----------------------------------------------------------------------- 
-- Whitelist 
-- ----------------------------------------------------------------------- 

CREATE TABLE Whitelist
(
    id INT NOT NULL,
    jpa_version INT,
    fUrl VARCHAR(200) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXWhitelist1 ON Whitelist (fUrl);

-- ----------------------------------------------------------------------- 
-- ApiKey 
-- ----------------------------------------------------------------------- 

CREATE TABLE ApiKey
(
    id INT NOT NULL,
    jpa_version INT,
    value VARCHAR(255) NOT NULL,
    email VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXApiKey1 ON ApiKey (value);

-- ----------------------------------------------------------------------- 
-- Feature 
-- ----------------------------------------------------------------------- 

CREATE TABLE Feature
(
    id INT NOT NULL,
    jpa_version INT,
    featureName VARCHAR(255) NOT NULL,
    required CHAR(1),
    widget_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXFeature1 ON Feature (widget_id);

-- ----------------------------------------------------------------------- 
-- Param 
-- ----------------------------------------------------------------------- 

CREATE TABLE Param
(
    id INT NOT NULL,
    jpa_version INT,
    feature_id INT,
    parameterName VARCHAR(255) NOT NULL,
    parameterValue VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXParam1 ON Param (feature_id);

-- ----------------------------------------------------------------------- 
-- ServerFeature 
-- ----------------------------------------------------------------------- 

CREATE TABLE ServerFeature
(
    id INT NOT NULL,
    jpa_version INT,
    featureName VARCHAR(255) NOT NULL,
    className VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXServerFeature1 ON ServerFeature (featureName);

-- ----------------------------------------------------------------------- 
-- Token 
-- ----------------------------------------------------------------------- 

CREATE TABLE Token
(
    id INT NOT NULL,
    jpa_version INT,
    requestUrl VARCHAR(255) NOT NULL,
    accessUrl VARCHAR(255) NOT NULL,
    authzUrl VARCHAR(255) NOT NULL,
    requestToken VARCHAR(255) NOT NULL,
    accessToken VARCHAR(255) NOT NULL,
    tokenSecret VARCHAR(255) NOT NULL,
    widget_instance_id INT,
    PRIMARY KEY (id)
);

CREATE INDEX IXToken1 ON Token (widget_instance_id);

ALTER TABLE WidgetIcon
    ADD CONSTRAINT FKWidgetIcon1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE License
    ADD CONSTRAINT FKLicense1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Name
    ADD CONSTRAINT FKName1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE AccessRequest
    ADD CONSTRAINT FKAccessRequest1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Description
    ADD CONSTRAINT FKDescription1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE StartFile
    ADD CONSTRAINT FKStartFile1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE WidgetInstance
    ADD CONSTRAINT FKWidgetInstance1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE PreferenceDefault
    ADD CONSTRAINT FKPreferenceDefault1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Participant
    ADD CONSTRAINT FKParticipant1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Preference
    ADD CONSTRAINT FKPreference1 FOREIGN KEY (widget_instance_id) REFERENCES WidgetInstance (id);

ALTER TABLE SharedData
    ADD CONSTRAINT FKSharedData1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE WidgetDefault
    ADD CONSTRAINT FKWidgetDefault1 FOREIGN KEY (widgetId) REFERENCES Widget (id);

ALTER TABLE WidgetType
    ADD CONSTRAINT FKWidgetType1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Feature
    ADD CONSTRAINT FKFeature1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Param
    ADD CONSTRAINT FKParam1 FOREIGN KEY (feature_id) REFERENCES Feature (id);

ALTER TABLE Token
    ADD CONSTRAINT FKToken1 FOREIGN KEY (widget_instance_id) REFERENCES WidgetInstance (id);

